Subject: Re: POHMELFS high performance network filesystem. Transactions, failover, performance.

From: Andrew Morton <[email-masked]>
Date: Wed, 14 May 2008 10:56:54 -0700

On Wed, 14 May 2008 06:41:53 -0700 (PDT) Sage Weil <[email-masked]> wrote:

> > On Wed, May 14, 2008 at 11:40:28AM +0400, Evgeniy Polyakov ([email-masked]) wrote:
> > > > If any thread takes more than one kmap() at a time, it is deadlockable.
> > > > Because there is a finite pool of kmaps.  Everyone can end up holding
> > > > one or more kmaps, then waiting for someone else to release one.
> > > 
> > > It never takes the whole LAST_PKMAP maps. So the same can be applied to
> > > any user who kmaps at least one page - while user waits for free slot,
> > > it can be reused by someone else and so on.
> > 
> > Actually CIFS uses the same logic: maps multiple pages in wrteback path
> > and release them after received reply.
> 
> Yes.  Only a pagevec at a time, though... apparently 14 is a small enough 
> number not to bite too many people in practice?
> 

In practice you need a large number of threads performing writeout to
trigger this.  iirc that's how it was demonstrated back in the 2.4
days.  Say, thousands of processes/threads doing write+fsync to
separate files.